Index: CKEditor/trunk/_source/plugins/colorbutton/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/colorbutton/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/colorbutton/plugin.js	(revision 5189)
@@ -32,10 +32,10 @@
 					panel :
 					{
-						css : editor.skin.editor.css
+						css : editor.skin.editor.css,
+						attributes : { role : 'listbox', 'aria-label' : lang.panelTitle }
 					},
 
-					onBlock : function( panel, blockName )
+					onBlock : function( panel, block )
 					{
-						var block = panel.addBlock( blockName );
 						block.autoSize = true;
 						block.element.addClass( 'cke_colorblock' );
@@ -44,6 +44,8 @@
 						var keys = block.keys;
 						keys[ 39 ]	= 'next';					// ARROW-RIGHT
+						keys[ 40 ]	= 'next';					// ARROW-DOWN
 						keys[ 9 ]	= 'next';					// TAB
 						keys[ 37 ]	= 'prev';					// ARROW-LEFT
+						keys[ 38 ]	= 'prev';					// ARROW-UP
 						keys[ CKEDITOR.SHIFT + 9 ]	= 'prev';	// SHIFT + TAB
 						keys[ 32 ]	= 'click';					// SPACE
@@ -56,5 +58,6 @@
 		{
 			var output = [],
-				colors = config.colorButton_colors.split( ',' );
+				colors = config.colorButton_colors.split( ',' ),
+				total = colors.length + ( config.colorButton_enableMore ? 2 : 1 );
 
 			var clickFn = CKEDITOR.tools.addFunction( function( color, type )
@@ -99,6 +102,7 @@
 					' title="', lang.auto, '"' +
 					' onclick="CKEDITOR.tools.callFunction(', clickFn, ',null,\'', type, '\');return false;"' +
-					' href="javascript:void(\'', lang.auto, '\')">' +
-					'<table cellspacing=0 cellpadding=0 width="100%">' +
+					' href="javascript:void(\'', lang.auto, '\')"' +
+					' role="option" aria-posinset="1" aria-setsize="', total, '">' +
+					'<table role="presentation" cellspacing=0 cellpadding=0 width="100%">' +
 						'<tr>' +
 							'<td>' +
@@ -111,5 +115,5 @@
 					'</table>' +
 				'</a>' +
-				'<table cellspacing=0 cellpadding=0 width="100%">' );
+				'<table role="presentation" cellspacing=0 cellpadding=0 width="100%">' );
 
 			// Render the color boxes.
@@ -126,5 +130,6 @@
 							' title="', colorLabel, '"' +
 							' onclick="CKEDITOR.tools.callFunction(', clickFn, ',\'#', colorCode, '\',\'', type, '\'); return false;"' +
-							' href="javascript:void(\'', colorLabel, '\')">' +
+							' href="javascript:void(\'', colorLabel, '\')"' +
+							' role="option" aria-posinset="', ( i + 2 ), '" aria-setsize="', total, '">' +
 							'<span class="cke_colorbox" style="background-color:#', colorCode, '"></span>' +
 						'</a>' +
@@ -142,5 +147,6 @@
 								' title="', lang.more, '"' +
 								' onclick="CKEDITOR.tools.callFunction(', clickFn, ',\'?\',\'', type, '\');return false;"' +
-								' href="javascript:void(\'', lang.more, '\')">',
+								' href="javascript:void(\'', lang.more, '\')"',
+								' role="option" aria-posinset="', total, '" aria-setsize="', total, '">',
 								lang.more,
 							'</a>' +
Index: CKEditor/trunk/_source/plugins/contextmenu/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/contextmenu/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/contextmenu/plugin.js	(revision 5189)
@@ -36,4 +36,16 @@
 			},
 			this);
+
+		this._.definiton =
+		{
+			panel:
+			{
+				className : editor.skinClass + ' cke_contextmenu',
+				attributes :
+				{
+					'aria-label' : editor.lang.common.options
+				}
+			}
+		};
 	},
 
@@ -52,5 +64,5 @@
 			else
 			{
-				menu = this._.menu = new CKEDITOR.menu( editor );
+				menu = this._.menu = new CKEDITOR.menu( editor, this._.definiton );
 				menu.onClick = CKEDITOR.tools.bind( function( item )
 				{
@@ -64,7 +76,24 @@
 				}, this );
 
-				menu.onEscape = function()
-				{
-					editor.focus();
+				menu.onEscape = function( keystroke )
+				{
+					var parent = this.parent;
+					// 1. If it's sub-menu, restore the last focused item
+					// of upper level menu.
+					// 2. In case of a top-menu, close it.
+					if ( parent )
+					{
+						parent._.panel.hideChild();
+						// Restore parent block item focus.
+						var parentBlock = parent._.panel._.panel._.currentBlock,
+							parentFocusIndex =  parentBlock._.focusIndex;
+						parentBlock._.markItem( parentFocusIndex );
+					}
+					else if ( keystroke == 27 )
+					{
+						this.hide();
+						editor.focus();
+					}
+					return false;
 				};
 			}
@@ -197,5 +226,5 @@
 					CKEDITOR.tools.setTimeout( function()
 						{
-							this._.onMenu( offsetParent, null, offsetX, offsetY );
+							this.show( offsetParent, null, offsetX, offsetY );
 						},
 						0, this );
Index: CKEditor/trunk/_source/plugins/dialog/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/dialog/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/dialog/plugin.js	(revision 5189)
@@ -128,4 +128,10 @@
 		this.parts = themeBuilt.parts;
 
+		CKEDITOR.tools.setTimeout( function()
+			{
+				editor.fire( 'ariaWidget', this.parts.contents );
+			},
+			0, this );
+
 		// Set the startup styles for the dialog, avoiding it enlarging the
 		// page size on the dialog creation.
@@ -245,4 +251,24 @@
 				}, this );
 
+		// Sort focus list according to tab order definitions.
+		function setupFocus()
+		{
+			var focusList = me._.focusList;
+			focusList.sort( function( a, b )
+				{
+					// Mimics browser tab order logics;
+					if ( a.tabIndex != b.tabIndex )
+						return b.tabIndex - a.tabIndex;
+					//  Sort is not stable in some browsers,
+					// fall-back the comparator to 'focusIndex';
+					else
+						return a.focusIndex - b.focusIndex;
+				});
+
+			var size = focusList.length;
+			for ( var i = 0; i < size; i++ )
+				focusList[ i ].focusIndex = i;
+		}
+
 		function changeFocus( forward )
 		{
@@ -252,5 +278,15 @@
 				return;
 
-			var startIndex = ( me._.currentFocusIndex + offset + focusList.length ) % focusList.length,
+			var current = me._.currentFocusIndex;
+
+			// Trigger the 'blur' event of  any input element before anything,
+			// since certain UI updates may depend on it.
+			try
+			{
+				focusList[ current ].getInputElement().$.blur();
+			}
+			catch( e ){}
+
+			var startIndex = ( current + offset + focusList.length ) % focusList.length,
 				currentIndex = startIndex;
 			while ( !focusList[ currentIndex ].isFocusable() )
@@ -266,4 +302,6 @@
 				focusList[ currentIndex ].select();
 		}
+
+		this.changeFocus = changeFocus;
 
 		var processed;
@@ -313,4 +351,12 @@
 				processed = 1;
 			}
+			else if ( ( keystroke == 13 || keystroke == 32 ) && me._.tabBarMode )
+			{
+				this.selectPage( this._.currentTabId );
+				this._.tabBarMode = false;
+				this._.currentFocusIndex = -1;
+				changeFocus( true );
+				processed = 1;
+			}
 
 			if ( processed )
@@ -326,12 +372,13 @@
 		}
 
+		var dialogElement = this._.element;
 		// Add the dialog keyboard handlers.
 		this.on( 'show', function()
 			{
-				CKEDITOR.document.on( 'keydown', focusKeydownHandler, this, null, 0 );
+				dialogElement.on( 'keydown', focusKeydownHandler, this, null, 0 );
 				// Some browsers instead, don't cancel key events in the keydown, but in the
 				// keypress. So we must do a longer trip in those cases. (#4531)
 				if ( CKEDITOR.env.opera || ( CKEDITOR.env.gecko && CKEDITOR.env.mac ) )
-					CKEDITOR.document.on( 'keypress', focusKeyPressHandler, this );
+					dialogElement.on( 'keypress', focusKeyPressHandler, this );
 
 				if ( CKEDITOR.env.ie6Compat )
@@ -343,7 +390,7 @@
 		this.on( 'hide', function()
 			{
-				CKEDITOR.document.removeListener( 'keydown', focusKeydownHandler );
+				dialogElement.removeListener( 'keydown', focusKeydownHandler );
 				if ( CKEDITOR.env.opera || ( CKEDITOR.env.gecko && CKEDITOR.env.mac ) )
-					CKEDITOR.document.removeListener( 'keypress', focusKeyPressHandler );
+					dialogElement.removeListener( 'keypress', focusKeyPressHandler );
 			} );
 		this.on( 'iframeAdded', function( evt )
@@ -356,8 +403,28 @@
 		this.on( 'show', function()
 			{
-				if ( !this._.hasFocus )
+				// Setup tabIndex on showing the dialog instead of on loading
+				// to allow dynamic tab order happen in dialog definition.
+				setupFocus();
+
+				if ( editor.config.dialog_startupFocusTab
+					&& me._.tabIdList.length > 1 )
+				{
+					me._.tabBarMode = true;
+					me._.tabs[ me._.currentTabId ][ 0 ].focus();
+				}
+				else if ( !this._.hasFocus )
 				{
 					this._.currentFocusIndex = -1;
-					changeFocus( true );
+
+					// Decide where to put the initial focus.
+					if ( definition.onFocus )
+					{
+						var initialFocus = definition.onFocus.call( this );
+						// Focus the field that the user specified.
+						initialFocus && initialFocus.focus();
+					}
+					// Focus the first field in layout order.
+					else
+						changeFocus( true );
 
 					/*
@@ -408,26 +475,20 @@
 			this.addPage( definition.contents[i] );
 
-		var tabRegex = /cke_dialog_tab(\s|$|_)/,
-			tabOuterRegex = /cke_dialog_tab(\s|$)/;
 		this.parts['tabs'].on( 'click', function( evt )
 				{
-					var target = evt.data.getTarget(), firstNode = target, id, page;
-
+					var target = evt.data.getTarget();
 					// If we aren't inside a tab, bail out.
-					if ( !( tabRegex.test( target.$.className ) || target.getName() == 'a' ) )
-						return;
-
-					// Find the outer <td> container of the tab.
-					id = target.$.id.substr( 0, target.$.id.lastIndexOf( '_' ) );
-					this.selectPage( id );
-
-					if ( this._.tabBarMode )
+					if ( target.hasClass( 'cke_dialog_tab' ) )
 					{
-						this._.tabBarMode = false;
-						this._.currentFocusIndex = -1;
-						changeFocus( true );
+						var id = target.$.id;
+						this.selectPage( id.substr( 0, id.lastIndexOf( '_' ) ) );
+						if ( this._.tabBarMode )
+						{
+							this._.tabBarMode = false;
+							this._.currentFocusIndex = -1;
+							changeFocus( true );
+						}
+						evt.data.preventDefault();
 					}
-
-					evt.data.preventDefault();
 				}, this );
 
@@ -454,4 +515,6 @@
 		this.element = element;
 		this.focusIndex = index;
+		// TODO: support tabIndex for focusables.
+		this.tabIndex = 0;
 		this.isFocusable = function()
 		{
@@ -811,15 +874,23 @@
 			// Create the HTML for the tab and the content block.
 			var page = CKEDITOR.dom.element.createFromHtml( pageHtml.join( '' ) );
-			var tab = CKEDITOR.dom.element.createFromHtml( [
+			page.setAttribute( 'role', 'tabpanel' );
+
+			var env = CKEDITOR.env;
+			var tabId = contents.id + '_' + CKEDITOR.tools.getNextNumber(),
+				 tab = CKEDITOR.dom.element.createFromHtml( [
 					'<a class="cke_dialog_tab"',
 						( this._.pageCount > 0 ? ' cke_last' : 'cke_first' ),
 						titleHtml,
 						( !!contents.hidden ? ' style="display:none"' : '' ),
-						' id="', contents.id + '_', CKEDITOR.tools.getNextNumber(), '"' +
-						' href="javascript:void(0)"',
-						' hidefocus="true">',
+						' id="', tabId, '"',
+						env.gecko && env.version >= 10900 && !env.hc ? '' : ' href="javascript:void(0)"',
+						' tabIndex="-1"',
+						' hidefocus="true"',
+						' role="tab">',
 							contents.label,
 					'</a>'
 				].join( '' ) );
+
+			page.setAttribute( 'aria-labelledby', tabId );
 
 			// If only a single page exist, a different style is used in the central pane.
@@ -881,4 +952,5 @@
 					page.hide();
 				}
+				page.setAttribute( 'aria-hidden', i != id );
 			}
 
@@ -1939,5 +2011,5 @@
 					styles = ( stylesArg && stylesArg.call ? stylesArg( elementDefinition ) : stylesArg ) || {},
 					attributes = ( attributesArg && attributesArg.call ? attributesArg( elementDefinition ) : attributesArg ) || {},
-					innerHTML = ( contentsArg && contentsArg.call ? contentsArg( dialog, elementDefinition ) : contentsArg ) || '',
+					innerHTML = ( contentsArg && contentsArg.call ? contentsArg.call( this, dialog, elementDefinition ) : contentsArg ) || '',
 					domId = this.domId = attributes.id || CKEDITOR.tools.getNextNumber() + '_uiElement',
 					id = this.id = elementDefinition.id,
@@ -2024,4 +2096,6 @@
 				if ( this.keyboardFocusable )
 				{
+					this.tabIndex = elementDefinition.tabIndex || 0;
+
 					this.focusIndex = dialog._.focusList.push( this ) - 1;
 					this.on( 'focus', function()
@@ -2086,5 +2160,5 @@
 						if ( i == childHtmlList.length - 1 )
 							className = 'cke_dialog_ui_hbox_last';
-						html.push( '<td class="', className, '" ' );
+						html.push( '<td class="', className, '" role="presentation" ' );
 						if ( widths )
 						{
@@ -2106,4 +2180,7 @@
 				};
 
+				var attribs = { role : 'presentation' };
+				elementDefinition && elementDefinition.align && ( attribs.align = elementDefinition.align );
+
 				CKEDITOR.ui.dialog.uiElement.call(
 					this,
@@ -2113,5 +2190,5 @@
 					'table',
 					styles,
-					elementDefinition && elementDefinition.align && { align : elementDefinition.align } || null,
+					attribs,
 					innerHTML );
 			},
@@ -2158,5 +2235,5 @@
 				var innerHTML = function()
 				{
-					var html = [ '<table cellspacing="0" border="0" ' ];
+					var html = [ '<table role="presentation" cellspacing="0" border="0" ' ];
 					html.push( 'style="' );
 					if ( elementDefinition && elementDefinition.expand )
@@ -2171,5 +2248,5 @@
 					{
 						var styles = [];
-						html.push( '<tr><td ' );
+						html.push( '<tr><td role="presentation" ' );
 						if ( width )
 							styles.push( 'width:' + CKEDITOR.tools.cssLength( width || '100%' ) );
@@ -2187,5 +2264,5 @@
 					return html.join( '' );
 				};
-				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition || { type : 'vbox' }, htmlList, 'div', null, null, innerHTML );
+				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition || { type : 'vbox' }, htmlList, 'div', null, { role : 'presentation' }, innerHTML );
 			}
 		};
@@ -2565,7 +2642,10 @@
 			editor.openDialog( this.dialogName );
 		},
+
 		// Dialog commands just open a dialog ui, thus require no undo logic,
 		// undo support should dedicate to specific dialog implementation.
-		canUndo: false
+		canUndo: false,
+
+		editorFocus : CKEDITOR.env.ie
 	};
 
@@ -2771,4 +2851,13 @@
 
 /**
+ * If the dialog has more than one tab, put focus into the first tab as soon as dialog is opened.
+ * @name CKEDITOR.config.dialog_startupFocusTab
+ * @type Boolean
+ * @default false
+ * @example
+ * config.dialog_startupFocusTab = true;
+ */
+
+/**
  * The distance of magnetic borders used in moving and resizing dialogs,
  * measured in pixels.
Index: CKEditor/trunk/_source/plugins/dialogui/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/dialogui/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/dialogui/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -14,4 +14,5 @@
 		this._ || ( this._ = {} );
 		this._['default'] = this._.initValue = elementDefinition['default'] || '';
+		this._.required = elementDefinition[ 'required' ] || false;
 		var args = [ this._ ];
 		for ( var i = 1 ; i < arguments.length ; i++ )
@@ -33,4 +34,21 @@
 		{
 			return new CKEDITOR.ui.dialog[elementDefinition.type]( dialog, elementDefinition, output );
+		}
+	},
+	containerBuilder =
+	{
+		build : function( dialog, elementDefinition, output )
+		{
+			var children = elementDefinition.children,
+				child,
+				childHtmlList = [],
+				childObjList = [];
+			for ( var i = 0 ; ( i < children.length && ( child = children[i] ) ) ; i++ )
+			{
+				var childHtml = [];
+				childHtmlList.push( childHtml );
+				childObjList.push( CKEDITOR.dialog._.uiElementBuilders[ child.type ].build( dialog, child, childHtml ) );
+			}
+			return new CKEDITOR.ui.dialog[ elementDefinition.type ]( dialog, childObjList, childHtmlList, output, elementDefinition );
 		}
 	},
@@ -130,11 +148,12 @@
 					var html = [];
 					if ( elementDefinition.labelLayout != 'horizontal' )
-						html.push( '<div class="cke_dialog_ui_labeled_label" id="',
-								_.labelId,
-								'" >',
+						html.push( '<label class="cke_dialog_ui_labeled_label" ',
+								' id="'+  _.labelId + '"',
+								' for="' + _.inputId + '"',
+								' style="' + elementDefinition.labelStyle + '">',
 								elementDefinition.label,
-								'</div>',
-								'<div class="cke_dialog_ui_labeled_content">',
-								contentHtml( dialog, elementDefinition ),
+								'</label>',
+								'<div class="cke_dialog_ui_labeled_content" role="presentation">',
+								contentHtml.call( this, dialog, elementDefinition ),
 								'</div>' );
 					else
@@ -148,6 +167,9 @@
 								{
 									type : 'html',
-									html : '<span class="cke_dialog_ui_labeled_label" ' +
-										'id="' + _.labelId + '">' +  CKEDITOR.tools.htmlEncode( elementDefinition.label ) +
+									html : '<label class="cke_dialog_ui_labeled_label"' +
+										' id="' + _.labelId + '"' +
+										' for="' + _.inputId + '"' +
+										' style="' + elementDefinition.labelStyle + '">' +
+										   CKEDITOR.tools.htmlEncode( elementDefinition.label ) +
 										'</span>'
 								},
@@ -155,5 +177,5 @@
 									type : 'html',
 									html : '<span class="cke_dialog_ui_labeled_content">' +
-										contentHtml( dialog, elementDefinition ) +
+										contentHtml.call( this, dialog, elementDefinition ) +
 										'</span>'
 								}
@@ -164,5 +186,5 @@
 					return html.join( '' );
 				};
-				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition, htmlList, 'div', null, null, innerHTML );
+				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition, htmlList, 'div', null, { role : 'presentation' }, innerHTML );
 			},
 
@@ -237,5 +259,5 @@
 					// IE BUG: Text input fields in IE at 100% would exceed a <td> or inline
 					// container's width, so need to wrap it inside a <div>.
-					var html = [ '<div class="cke_dialog_ui_input_', elementDefinition.type, '"' ];
+					var html = [ '<div class="cke_dialog_ui_input_', elementDefinition.type, '" role="presentation"' ];
 
 					if ( elementDefinition.width )
@@ -243,4 +265,7 @@
 
 					html.push( '><input ' );
+
+					attributes[ 'aria-labelledby' ] = this._.labelId;
+					this._.required && ( attributes[ 'aria-required' ] = this._.required );
 					for ( var i in attributes )
 						html.push( i + '="' + attributes[i] + '" ' );
@@ -291,5 +316,7 @@
 				var innerHTML = function()
 				{
-					var html = [ '<div class="cke_dialog_ui_input_textarea"><textarea class="cke_dialog_ui_input_textarea" id="', domId, '" ' ];
+					attributes[ 'aria-labelledby' ] = this._.labelId;
+					this._.required && ( attributes[ 'aria-required' ] = this._.required );
+					var html = [ '<div class="cke_dialog_ui_input_textarea" role="presentation"><textarea class="cke_dialog_ui_input_textarea" id="', domId, '" ' ];
 					for ( var i in attributes )
 						html.push( i + '="' + CKEDITOR.tools.htmlEncode( attributes[i] ) + '" ' );
@@ -335,11 +362,13 @@
 								id : elementDefinition.id ? elementDefinition.id + '_checkbox' : CKEDITOR.tools.getNextNumber() + '_checkbox'
 							}, true ),
-						html = [],
-						attributes = { 'class' : 'cke_dialog_ui_checkbox_input', type : 'checkbox' };
+						html = [];
+
+					var labelId = CKEDITOR.tools.getNextNumber() + '_label';
+					var attributes = { 'class' : 'cke_dialog_ui_checkbox_input', type : 'checkbox', 'aria-labelledby' : labelId };
 					cleanInnerDefinition( myDefinition );
 					if ( elementDefinition[ 'default' ] )
 						attributes.checked = 'checked';
 					_.checkbox = new CKEDITOR.ui.dialog.uiElement( dialog, myDefinition, html, 'input', null, attributes );
-					html.push( ' <label for="', attributes.id, '">',
+					html.push( ' <label id="', labelId, '" for="', attributes.id, '">',
 							CKEDITOR.tools.htmlEncode( elementDefinition.label ),
 							'</label>' );
@@ -386,5 +415,5 @@
 				{
 					var inputHtmlList = [], html = [],
-						commonAttributes = { 'class' : 'cke_dialog_ui_radio_item' },
+						commonAttributes = { 'class' : 'cke_dialog_ui_radio_item', 'aria-labelledby' : this._.labelId },
 						commonName = elementDefinition.id ? elementDefinition.id + '_radio' : CKEDITOR.tools.getNextNumber() + '_radio';
 					for ( var i = 0 ; i < elementDefinition.items.length ; i++ )
@@ -393,7 +422,9 @@
 							title = item[2] !== undefined ? item[2] : item[0],
 							value = item[1] !== undefined ? item[1] : item[0],
+							inputId = CKEDITOR.tools.getNextNumber() + '_radio_input',
+							labelId = inputId + '_label',
 							inputDefinition = CKEDITOR.tools.extend( {}, elementDefinition,
 									{
-										id : CKEDITOR.tools.getNextNumber() + '_radio_input',
+										id : inputId,
 										title : null,
 										type : null
@@ -401,5 +432,4 @@
 							labelDefinition = CKEDITOR.tools.extend( {}, inputDefinition,
 									{
-										id : null,
 										title : title
 									}, true ),
@@ -409,5 +439,6 @@
 								'class' : 'cke_dialog_ui_radio_input',
 								name : commonName,
-								value : value
+								value : value,
+								'aria-labelledby' : labelId
 							},
 							inputHtml = [];
@@ -418,5 +449,5 @@
 						children.push( new CKEDITOR.ui.dialog.uiElement( dialog, inputDefinition, inputHtml, 'input', null, inputAttributes ) );
 						inputHtml.push( ' ' );
-						new CKEDITOR.ui.dialog.uiElement( dialog, labelDefinition, inputHtml, 'label', null, { 'for' : inputAttributes.id },
+						new CKEDITOR.ui.dialog.uiElement( dialog, labelDefinition, inputHtml, 'label', null, { id : labelId, 'for' : inputAttributes.id },
 							   item[0] );
 						inputHtmlList.push( inputHtml.join( '' ) );
@@ -474,4 +505,13 @@
 									evt.data.preventDefault();
 								} );
+
+							element.on( 'keydown', function( evt )
+								{
+									if ( evt.data.getKeystroke() in { 32:1, 13:1 } )
+									{
+										me.click();
+										evt.data.preventDefault();
+									}
+								} );
 						})();
 
@@ -482,4 +522,5 @@
 				delete outerDefinition.style;
 
+				var labelId = CKEDITOR.tools.getNextNumber() + '_label';
 				CKEDITOR.ui.dialog.uiElement.call(
 					this,
@@ -494,7 +535,9 @@
 						title : elementDefinition.label,
 						hidefocus : 'true',
-						'class' : elementDefinition['class']
+						'class' : elementDefinition['class'],
+						role : 'button',
+						'aria-labelledby' : labelId
 					},
-					'<span class="cke_dialog_ui_button">' +
+					'<span id="' + labelId + '" class="cke_dialog_ui_button">' +
 						CKEDITOR.tools.htmlEncode( elementDefinition.label ) +
 					'</span>' );
@@ -535,4 +578,5 @@
 					this.validate = elementDefinition.validate;
 
+				_.inputId = CKEDITOR.tools.getNextNumber() + '_select';
 				/** @ignore */
 				var innerHTML = function()
@@ -544,5 +588,5 @@
 						html = [],
 						innerHTML = [],
-						attributes = { 'class' : 'cke_dialog_ui_input_select' };
+						attributes = { 'id' : _.inputId, 'class' : 'cke_dialog_ui_input_select', 'aria-labelledby' : this._.labelId };
 
 					// Add multiple and size attributes from element definition.
@@ -724,5 +768,6 @@
 
 					// Look for focus function in definition.
-					if ( elementDefinition.focus )
+					var focus = elementDefinition.focus;
+					if ( focus )
 					{
 						var oldFocus = this.focus;
@@ -730,5 +775,5 @@
 						{
 							oldFocus.call( this );
-							elementDefinition.focus.call( this );
+							typeof focus == 'function' && focus.call( this );
 							this.fire( 'focus' );
 						};
@@ -756,5 +801,43 @@
 					htmlList.push( [ theirMatch[1], ' ', myMatch[1] || '', theirMatch[2] ].join( '' ) );
 				};
-			})()
+			})(),
+
+			/**
+			 * Form fieldset for grouping dialog UI elements.
+			 * @constructor
+			 * @extends CKEDITOR.ui.dialog.uiElement
+			 * @param {CKEDITOR.dialog} dialog Parent dialog object.
+			 * @param {Array} childObjList
+			 * Array of {@link CKEDITOR.ui.dialog.uiElement} objects inside this
+			 * container.
+			 * @param {Array} childHtmlList
+			 * Array of HTML code that correspond to the HTML output of all the
+			 * objects in childObjList.
+			 * @param {Array} htmlList
+			 * Array of HTML code that this element will output to.
+			 * @param {CKEDITOR.dialog.uiElementDefinition} elementDefinition
+			 * The element definition. Accepted fields:
+			 * <ul>
+			 * 	<li><strong>label</strong> (Optional) The legend of the this fieldset.</li>
+			 * 	<li><strong>children</strong> (Required) An array of dialog field definitions which will be grouped inside this fieldset. </li>
+			 * </ul>
+			 */
+			fieldset : function( dialog, childObjList, childHtmlList, htmlList, elementDefinition )
+			{
+				var legendLabel = elementDefinition.label;
+				/** @ignore */
+				var innerHTML = function()
+				{
+					var html = [];
+					legendLabel && html.push( '<legend>' + legendLabel + '</legend>' );
+					for ( var i = 0; i < childHtmlList.length; i++ )
+						html.push( childHtmlList[ i ] );
+					return html.join( '' );
+				};
+
+				this._ = { children : childObjList };
+				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition, htmlList, 'fieldset', null, null, innerHTML );
+			}
+
 		}, true );
 
@@ -1310,4 +1393,6 @@
 	CKEDITOR.ui.dialog.fileButton.prototype = new CKEDITOR.ui.dialog.button;
 
+	CKEDITOR.ui.dialog.fieldset.prototype = CKEDITOR.tools.clone( CKEDITOR.ui.dialog.hbox.prototype );
+
 	CKEDITOR.dialog.addUIElement( 'text', textBuilder );
 	CKEDITOR.dialog.addUIElement( 'password', textBuilder );
@@ -1320,3 +1405,4 @@
 	CKEDITOR.dialog.addUIElement( 'fileButton', commonBuilder );
 	CKEDITOR.dialog.addUIElement( 'html', commonBuilder );
+	CKEDITOR.dialog.addUIElement( 'fieldset', containerBuilder );
 })();
Index: CKEditor/trunk/_source/plugins/div/dialogs/div.js
===================================================================
--- CKEditor/trunk/_source/plugins/div/dialogs/div.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/div/dialogs/div.js	(revision 5189)
@@ -260,4 +260,27 @@
 		}
 
+		// Synchronous field values to other impacted fields is required, e.g. div styles
+		// change should also alter inline-style text.
+		function commitInternally( targetFields )
+		{
+			var dialog = this.getDialog(),
+				 element = dialog._element && dialog._element.clone()
+						 || new CKEDITOR.dom.element( 'div', editor.document );
+
+			// Commit this field and broadcast to target fields.
+			this.commit( element, true );
+
+			targetFields = [].concat( targetFields );
+			var length = targetFields.length, field;
+			for ( var i = 0; i < length; i++ )
+			{
+				field = dialog.getContentElement.apply( dialog, targetFields[ i ].split( ':' ) );
+				field && field.setup && field.setup( element, true );
+			}
+		}
+
+
+		// Registered 'CKEDITOR.style' instances.
+		var styles = {} ;
 		/**
 		 * Hold a collection of created block container elements.
@@ -290,15 +313,23 @@
 								label :editor.lang.div.styleSelectLabel,
 								'default' : '',
-								items : [],
+								// Options are loaded dynamically.
+								items :
+								[
+									[ editor.lang.common.notSet , '' ]
+								],
+								onChange : function()
+								{
+									commitInternally.call( this, [ 'info:class', 'advanced:dir', 'advanced:style' ] );
+								},
 								setup : function( element )
 								{
-									this.setValue( element.$.style.cssText || '' );
+									for ( var name in styles )
+										styles[ name ].checkElementRemovable( element, true ) && this.setValue( name );
 								},
 								commit: function( element )
 								{
-									if ( this.getValue() )
-										element.$.style.cssText = this.getValue();
-									else
-										element.removeAttribute( 'style' );
+									var styleName;
+									if ( ( styleName = this.getValue() ) )
+										styles[ styleName ].applyToObject( element );
 								}
 							},
@@ -352,5 +383,12 @@
 											style :'width: 100%;',
 											label :editor.lang.common.cssStyle,
-											'default' : ''
+											'default' : '',
+											commit : function( element )
+											{
+												// Merge with 'elementStyle', which is of higher priority.
+												var value = this.getValue(),
+														merged = [ value, element.getAttribute( 'style' ) ].join( ';' );
+												value && element.setAttribute( 'style', merged );
+											}
 										}
 								]
@@ -377,4 +415,5 @@
 								items :
 								[
+									[ editor.lang.common.notSet , '' ],
 									[
 										editor.lang.common.langDirLtr,
@@ -395,4 +434,47 @@
 			{
 				setupFields.call(this);
+
+				// Preparing for the 'elementStyle' field.
+				var dialog = this,
+					 stylesField = this.getContentElement( 'info', 'elementStyle' ),
+					 // Reuse the 'stylescombo' plugin's styles definition.
+					 customStylesConfig =  editor.config.stylesCombo_stylesSet,
+					 stylesSetName = customStylesConfig && customStylesConfig.split( ':' )[ 0 ];
+
+				if ( stylesSetName )
+				{
+					CKEDITOR.stylesSet.load( stylesSetName,
+						function( stylesSet )
+						{
+							var stylesDefinitions = stylesSet[ stylesSetName ],
+								styleName;
+
+							if ( stylesDefinitions )
+							{
+								// Digg only those styles that apply to 'div'.
+								for ( var i = 0 ; i < stylesDefinitions.length ; i++ )
+								{
+									var styleDefinition = stylesDefinitions[ i ];
+									if ( styleDefinition.element && styleDefinition.element == 'div' )
+									{
+										styleName = styleDefinition.name;
+										styles[ styleName ] = new CKEDITOR.style( styleDefinition );
+
+										// Populate the styles field options with style name.
+										stylesField.items.push( [ styleName, styleName ] );
+										stylesField.add( styleName, styleName );
+									}
+								}
+							}
+
+
+							// We should disable the content element
+							// it if no options are available at all.
+							stylesField[ stylesField.items.length > 1 ? 'enable' : 'disable' ]();
+
+							// Now setup the field value manually.
+							setTimeout( function() { stylesField.setup( dialog._element ); }, 0 );
+						} );
+				}
 			},
 			onShow : function()
@@ -417,7 +499,18 @@
 
 				// Update elements attributes
-				for ( var i = 0 ; i < containers.length ; i++ )
+				var size = containers.length;
+				for ( var i = 0; i < size; i++ )
+				{
 					this.commitContent( containers[ i ] );
+
+					// Remove empty 'style' attribute.
+					!containers[ i ].getAttribute( 'style' ) && containers[ i ].removeAttribute( 'style' );
+				}
+
 				this.hide();
+			},
+			onHide : function()
+			{
+				delete this._element;
 			}
 		};
Index: CKEditor/trunk/_source/plugins/div/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/div/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/div/plugin.js	(revision 5189)
@@ -13,5 +13,5 @@
 	CKEDITOR.plugins.add( 'div',
 	{
-		requires : [ 'editingblock', 'domiterator' ],
+		requires : [ 'editingblock', 'domiterator', 'styles' ],
 
 		init : function( editor )
